/*
 *	Calculator
 *
 *	Ver 0.00	07/16/1998	T.Tashiro (Takashi.Tashiro@nifty.ne.jp)
 */
/************************************************************************
 *									*
 *	LICENCED MATERIAL OF Takashi Tashiro				*
 *	REPRODUCTION, USE, MODIFICATION,DISCLOSURE OTHERWISE THAN	*
 *	PERMITTED IN THE LICENCE AGREEMENT IS STRICTLY PROHIBITED.	*
 *	COPYRIGHT (C) T.TASHIRO 1998.         ALL RIGHTS RESERVED.	*
 *									*
 ************************************************************************/

import java.util.*;
import java.applet.*;										   
import java.awt.*;
import java.awt.datatransfer.*;
import java.awt.event.*;
import java.text.*;

public class TkCalc extends Applet implements Runnable
{
	int base;				// base number for calculation
	static boolean is_app = false;		// is this applet ?
	static Frame top_frame;			// top frame window
	tcalcButtons button;			// button panel
	tcalcNumDisp num_disp;			// number display

	/*
	 *	Initialize TkCalc object
	 */
	public void init() {
		// create calender canvas and control panel
		setLayout(new BorderLayout());
		button = new tcalcButtons(this);
		num_disp = new tcalcNumDisp(this);
		num_disp.setFont(new Font("Courier", Font.PLAIN, 14));
		add("North", num_disp);
		add("Center", button);
	}

	public void start() {
	}

	public void stop() {
	}

	public void paint(Graphics g) {
	}

	public void run() {
	}

	public static void main(String args[]) {
		is_app = true;

		top_frame = new Frame("TkCalc");
		TkCalc tcalc = new TkCalc();

		tcalc.init();
		tcalc.start();

		top_frame.add("Center", tcalc);
		top_frame.setSize(350,300);
		top_frame.show();

		// set window listener to quit program when window close button was pushed.
		top_frame.addWindowListener(new tcalcWinAdapter());
	}
}

/*
 *	This is window listener to quit program when window close button was pushed
 */
class tcalcWinAdapter extends WindowAdapter
{
	public void windowClosing(WindowEvent e) {
		System.exit(0);
	}
}

/*
 *	push button pannel
 */
class tcalcButtons extends Panel
                  implements ActionListener, ItemListener
{
	TkCalc tcalc;
	Button b;
	CheckboxGroup chk_grp;
	Checkbox chk;
	long old_val = 0;
	long bef_val = 0;
	boolean bef_equ = false;
	char operator = '\0';
	boolean clear_and_set = false;
	static String btn_str[] = {
		                           "A",
		"+/-", "&",   "|",   "+",  "B",
		"7",   "8",   "9",   "-",  "C",
		"4",   "5",   "6",   "*",  "D",
		"1",   "2",   "3",   "/",  "E",
		"0",   " ",   "AC",  "=",  "F",
		null };

	/*
	 *	constructor
	 */
	public tcalcButtons(TkCalc tcalc) {
		this.tcalc = tcalc;

		Button b = null;

		setLayout(new GridLayout(6,5));

		tcalc.base = 10;
		chk_grp = new CheckboxGroup();
		chk = new Checkbox("Hex",false,chk_grp);
		chk.addItemListener(this);
		add(chk);
		chk = new Checkbox("Dec",true,chk_grp);
		chk.addItemListener(this);
		add(chk);
		chk = new Checkbox("Oct",false,chk_grp);
		chk.addItemListener(this);
		add(chk);
		chk = new Checkbox("Bin",false,chk_grp);
		chk.addItemListener(this);
		add(chk);

		Font fnt = new Font("Courier", Font.BOLD, 14);
		for ( int c = 0 ; btn_str[c] != null ; c++ ) {
			b = new Button(btn_str[c]);
			b.setFont(fnt);
			b.addActionListener(this);
			if ( btn_str[c].length() == 1 && 
				((btn_str[c].charAt(0) >= '0' && btn_str[c].charAt(0) <= '9')
				|| (btn_str[c].charAt(0) >= 'A' && btn_str[c].charAt(0) <= 'F')) ) {
				b.setForeground(Color.black);
			} else {
				b.setForeground(Color.magenta);
			}
			add(b);
		}
	}

	public Dimension getPreferredSize() {
		return new Dimension(100,30);
	}

	/*
	 *	button pushed
	 */
	public void actionPerformed(ActionEvent ev) {
		String label = ev.getActionCommand();
		doIt(label);
	}

	public void doIt(String ch) {
		// System.out.println(ch);
		if ( ch.equals("AC") ) {
			bef_equ = false;
			operator = '\0';
			tcalc.num_disp.setText("");
		} else if ( (ch.charAt(0) >= '0' && ch.charAt(0) <= '9')
			|| (ch.charAt(0) >= 'A' && ch.charAt(0) <= 'Z') ) {
			String str = tcalc.num_disp.getText();
			if ( str.equals("0") || clear_and_set ) {
				str = "";
				clear_and_set = false;
			}
			tcalc.num_disp.setText(str + ch.charAt(0));
		} else if ( ch.equals("+") || ch.equals("-")
			|| ch.equals("/") || ch.equals("*")
			|| ch.equals("&") || ch.equals("|") ) {
			if ( bef_equ ) operator = '\0';
			perform_calculation(ch.charAt(0));
			operator = ch.charAt(0);
			clear_and_set = true;
			bef_equ = false;
		} else if ( ch.equals("=") ) {
			perform_calculation(ch.charAt(0));
			clear_and_set = true;
			bef_equ = true;
		} else if ( ch.equals("+/-") ) {
			clear_and_set = true;
			try {
				bef_val = Long.parseLong(tcalc.num_disp.getText(),tcalc.base);
			} catch (NumberFormatException ex) {
				bef_val = 0;
			}
			bef_val = -bef_val;
			tcalc.num_disp.setText(Long.toString(bef_val,tcalc.base).toUpperCase());
		}
	}

	void perform_calculation(char new_op) {
		if ( new_op != '=' || !bef_equ ) {
			try {
				bef_val = Long.parseLong(tcalc.num_disp.getText(),tcalc.base);
			} catch (NumberFormatException ex) {
				bef_val = 0;
			}
		}
		switch ( operator ) {
			case '+' :
				old_val = old_val + bef_val;
				break;
			case '-' :
				old_val = old_val - bef_val;
				break;
			case '*' :
				old_val = old_val * bef_val;
				break;
			case '/' :
				old_val = old_val / bef_val;
				break;
			case '&' :
				old_val = old_val & bef_val;
				break;
			case '|' :
				old_val = old_val | bef_val;
				break;
			default :
				old_val = bef_val;
				break;
		}
		tcalc.num_disp.setText(Long.toString(old_val,tcalc.base).toUpperCase());
	}

	/*
	 *	checkbox selected to change base number
	 */
	public void itemStateChanged(ItemEvent ev) {
		String label = ((Checkbox)(ev.getItemSelectable())).getLabel();
		// System.out.println(label);
		String str = tcalc.num_disp.getText();
		long val;
		try {
			val = Long.parseLong(str,tcalc.base);
		} catch (NumberFormatException ex) {
			val = 0;
		}
		if ( ev.getStateChange() == ItemEvent.SELECTED ) {
			if ( label.equals("Hex") ) {
				tcalc.base = 16;
			} else if ( label.equals("Dec") ) {
				tcalc.base = 10;
			} else if ( label.equals("Oct") ) {
				tcalc.base = 8;
			} else if ( label.equals("Bin") ) {
				tcalc.base = 2;
			}
			tcalc.num_disp.setText(Long.toString(val,tcalc.base).toUpperCase());
		}
	}
}

/*
 *	number display panel
 */
class tcalcNumDisp extends Canvas
		implements ClipboardOwner, KeyListener
{
	String text = "";
	TkCalc tcalc;
	int font_height;
	int font_width;
	Clipboard clipboard = getToolkit().getSystemClipboard();
	StringSelection str_selection;

	tcalcNumDisp(TkCalc tcalc) {
		this.tcalc = tcalc;
		addKeyListener(this);
	}

	public void paint(Graphics g) {
		Dimension sz;
		sz = getSize();
		g.clearRect(0, 0, sz.width, sz.height);
		g.draw3DRect(1, 1, sz.width - 4, sz.height - 4, false);

		int len = text.length();
		int blk = (tcalc.base == 10) ? 3 : (tcalc.base == 2) ? 8 : 4;
		int blk_sp = font_width / 3;
		int blk_cn = (len - 1) / blk;
		int x = sz.width - 10 - len * font_width - blk_cn * blk_sp;
		int c;
		for ( c = 0 ; c < len ; c++ ) {
			g.drawString(text.substring(c, c + 1), x, font_height * 3 / 2);
			x += font_width;
			if ( ((len - c - 1) % blk) == 0 ) x += blk_sp;
		}
	}

	public void setText(String text) {
		String tex = new String(text);
		this.text = tex;
		str_selection = new StringSelection(tex);
		clipboard.setContents(str_selection, this);
		repaint();
	}

	public String getText() {
		String ret_text;
		ret_text = new String(text);

		return ret_text;
	}

	public boolean isFocusTraversable() {
		return true;
	}

	/*
	 *	need for ClipboardOwner implements
	 */
	public void lostOwnership(Clipboard clipboard, Transferable contents) {
	}

	public Dimension getPreferredSize() {
		return getMinimumSize();
	}
	
	public Dimension getMinimumSize() {

		FontMetrics met = getFontMetrics(getFont());
		font_height = met.getHeight();
		font_width = met.getMaxAdvance();

		Dimension min_size = new Dimension();
		min_size.width = 100;
		min_size.height = font_height * 2;

		return min_size;
	}

	/*
	 *	keyboard listener
	 */
	public void keyPressed(KeyEvent e) {
	}

	public void keyReleased(KeyEvent e) {
	}

	public void keyTyped(KeyEvent e) {
		String str = e.getKeyChar() + "";
		tcalc.button.doIt(str.toUpperCase());
	}
}

